%% Ignore Msg Hole Name
-define(eTpfHole, '$eTpfHole').

%% 消息截取默认配置项
-define(tcmIsCut, false).
-define(tcmDepth, 3).
-define(tcmListSize, 32).
-define(tcmMapSize, 32).
-define(tcmTupleSize, 32).
-define(tcmBinSize, 128).
-define(tcmBitSize, ?tcmBinSize * 8).
-define(tcmNestStruct, 6).

%% 类型声明
-export_type([input/0, userInput/0, traceOpts/0, tracerOpts/0]).

-type pattern() :: module() | {app, atom()} | {callback, module(), atom()}.

-type scope() :: {scope, [pid() | port() | all | processes | ports |existing | existing_processes | existing_ports |new | new_processes | new_ports]}.
-type input() :: [pattern() | scope()].

-type userInput() :: pattern() | input().

-type traceOpts() :: #{
mode => trace | profile
, poolId => any()
, poolSize => pos_integer()
, send => boolean()
, running => boolean()
}.

-type tracerOpts() :: #{
   %% tracer for socket
	port => pos_integer()

   %% tracer for file
   ,filename_prefix => string()
   , max_size => pos_integer()
   , events_per_frame => pos_integer()

   %% tracer for console

   %% trace msg term cut cfg
   ,tcmIsCut => boolean()                 %% 是否cut trace msg term
   ,tcmDepth => boolean()                 %% term cut时保留的最大深度
   ,tcmListSize => boolean()              %% List term cut时保留的最大数量
   ,tcmMapSize => boolean()               %% Map term cut时保留的最大数量
   ,tcmTupleSize => boolean()             %% Tuple term cut时保留的最大数量
   ,tcmBitSize => boolean()               %% Bits term cut时保留的最大字节数
   ,tcmNestStruct => boolean()            %% 复合结构 term cut时保留的最大数量
}.